Task to run phpDocumentor with an external process

This classes uses the commandline phpdoc script to build documentation. Use this task instead of the PhpDocumentorTask when you've a clash with the Smarty libraries.

author | Michiel Rook
author | Markus Fischer
version | $Id: 6a6c740651bb91c9854fcdf0cb1d7e768b84f805 $
package | phing.tasks.ext.phpdoc
copyright | 2001,2002 THYRELL. All rights reserved

### Methods

## Creates a FileSet.

    createFileset() : \FileSet

Inherited

inherited_from | \PhpDocumentorTask::createFileset()

### Returns

`\FileSet`

## Creates a readme/install/changelog fileset.

    createProjdocfileset() : \FileSet

Inherited

inherited_from | \PhpDocumentorTask::createProjdocfileset()

### Returns

`\FileSet`

## Returns the textual description of the task

    getDescription() : string

Inherited

inherited_from | \Task::getDescription()
inherited_from | \PhpDocumentorTask::getDescription()

### Returns

`string`The text description of the task

## Returns the location within the buildfile this task occurs.

    getLocation() : \Location

Inherited

Used by BuildException to give detailed error messages.

inherited_from | \Task::getLocation()
inherited_from | \PhpDocumentorTask::getLocation()

### Returns

`\Location`The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

Inherited

inherited_from | \Task::getOwningTarget()
inherited_from | \PhpDocumentorTask::getOwningTarget()

### Returns

`\Target`The target object that owns this task

## Returns the path to the phpDocumentor executable

    getProgramPath()

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()
inherited_from | \Task::getProject()
inherited_from | \PhpDocumentorTask::getProject()

### Returns

`\Project`Reference to current porject object

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

Inherited

inherited_from | \Task::getRuntimeConfigurableWrapper()
inherited_from | \PhpDocumentorTask::getRuntimeConfigurableWrapper()

### Returns

`\RuntimeConfigurable`The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

Inherited

inherited_from | \Task::getTaskName()
inherited_from | \PhpDocumentorTask::getTaskName()

### Returns

`string`Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

Inherited

inherited_from | \Task::getTaskType()
inherited_from | \PhpDocumentorTask::getTaskType()

### Returns

`string`The type of this task (XML Tag)

## Override PhpDocumentorTask::init() because they're specific to the phpdoc API which we don't use.

    init()

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

### Exceptions

`\BuildException` |

## Provides a project level log event to the task.

    log(string $msg, integer $level)

Inherited

see | \global\BuildEvent
see | \global\BuildListener
inherited_from | \Task::log()
inherited_from | \PhpDocumentorTask::log()

### Parameters

#### $msg

`string`

The message to log

#### $level

`integer`

The priority of the message

## Main entrypoint of the task

    main()

This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running phing target1 target2 will run all tasks in target3 twice.

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

### Exceptions

`\BuildException` | - if the phpdoc classes can't be loaded.

## Configure this task if it hasn't been done already.

    maybeConfigure()

Inherited

inherited_from | \Task::maybeConfigure()
inherited_from | \PhpDocumentorTask::maybeConfigure()

## Perfrom this task

    perform()

Inherited

inherited_from | \Task::perform()
inherited_from | \PhpDocumentorTask::perform()

## Set a directory to search for configuration files in.

    setConfigdir(\PhingFile $d)

Inherited

inherited_from | \PhpDocumentorTask::setConfigdir()

### Parameters

#### $d

`\PhingFile`

## custom tags, will be recognized and put in tags[] instead of unknowntags[].

    setCustomtags(string $sCustomtags)

Inherited

inherited_from | \PhpDocumentorTask::setCustomtags()

### Parameters

#### $sCustomtags

`string`

## Sets the default category name.

    setDefaultcategoryname(string $name)

Inherited

inherited_from | \PhpDocumentorTask::setDefaultcategoryname()

### Parameters

#### $name

`string`

## Sets the default package name.

    setDefaultpackagename(string $name)

Inherited

inherited_from | \PhpDocumentorTask::setDefaultpackagename()

### Parameters

#### $name

`string`

## Sets a textual description of the task

    setDescription(string $desc)

Inherited

inherited_from | \Task::setDescription()
inherited_from | \PhpDocumentorTask::setDescription()

### Parameters

#### $desc

`string`

The text describing the task

## Set the destination directory for the generated documentation

    setDestdir(\PhingFile $destdir)

Inherited

inherited_from | \PhpDocumentorTask::setDestdir()

### Parameters

#### $destdir

## Set a directory to search for examples in.

    setExamplesdir(\PhingFile $d)

Inherited

inherited_from | \PhpDocumentorTask::setExamplesdir()

### Parameters

#### $d

`\PhingFile`

## Set files to ignore

    setIgnore(string $sIgnore)

Inherited

inherited_from | \PhpDocumentorTask::setIgnore()

### Parameters

#### $sIgnore

`string`

## Ignore symlinks to other files or directories.

    setIgnoresymlinks(bool $bSet)

### Parameters

#### $bSet

`bool`

## Set (comma-separated) list of tags to ignore.

    setIgnoretags(string $tags)

Inherited

inherited_from | \PhpDocumentorTask::setIgnoretags()

### Parameters

#### $tags

`string`

## Whether to use javadoc descriptions (more primitive).

    setJavadocdesc(boolean $javadoc)

Inherited

inherited_from | \PhpDocumentorTask::setJavadocdesc()

### Parameters

#### $javadoc

`boolean`

## Set whether to generate sourcecode for each file parsed

    setLinksource(boolean $b)

Inherited

inherited_from | \PhpDocumentorTask::setLinksource()

### Parameters

#### $b

`boolean`

## Sets the location within the buildfile this task occurs.

    setLocation(\Location $location)

Inherited

Called by the parser to set location information.

inherited_from | \Task::setLocation()
inherited_from | \PhpDocumentorTask::setLocation()

### Parameters

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Set the output format (e.g.

    setOutput(string $output)

Inherited

HTML:Smarty:PHP).

inherited_from | \PhpDocumentorTask::setOutput()

### Parameters

#### $output

`string`

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

Inherited

inherited_from | \Task::setOwningTarget()
inherited_from | \PhpDocumentorTask::setOwningTarget()

### Parameters

#### $target

`\Target`

Reference to owning target

## Set (comma-separated) list of packages to output.

    setPackageoutput(string $packages)

Inherited

inherited_from | \PhpDocumentorTask::setPackageoutput()

### Parameters

#### $packages

`string`

## Should private members/classes be documented

    setParseprivate(boolean $parseprivate)

Inherited

inherited_from | \PhpDocumentorTask::setParseprivate()

### Parameters

#### $parseprivate

`boolean`

## Set whether to parse as PEAR repository.

    setPear(boolean $b)

Inherited

inherited_from | \PhpDocumentorTask::setPear()

### Parameters

#### $b

`boolean`

## Sets the path to the phpDocumentor executable

    setProgramPath($programPath)

### Parameters

#### $programPath

## References the project to the current component.

    setProject(\Project $project)

Inherited

inherited_from | \ProjectComponent::setProject()
inherited_from | \Task::setProject()
inherited_from | \PhpDocumentorTask::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## Set whether to suppress output.

    setQuiet(boolean $b)

Inherited

inherited_from | \PhpDocumentorTask::setQuiet()

### Parameters

#### $b

`boolean`

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

Inherited

inherited_from | \Task::setRuntimeConfigurableWrapper()
inherited_from | \PhpDocumentorTask::setRuntimeConfigurableWrapper()

### Parameters

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Set whether to generate sourcecode for each file parsed

    setSourcecode(boolean $b)

Inherited

inherited_from | \PhpDocumentorTask::setSourcecode()

### Parameters

#### $b

`boolean`

## Set the source path.

    setSourcepath($sourcepath)

A directory or a comma separate list of directories.

### Parameters

#### $sourcepath

## Alias for {@link setDestdir()}.

    setTarget(\PhingFile $destdir)

Inherited

see | \global\setDestdir()
inherited_from | \PhpDocumentorTask::setTarget()

### Parameters

#### $destdir

## Sets the name of this task for log messages

    setTaskName(string $name) : string

Inherited

inherited_from | \Task::setTaskName()
inherited_from | \PhpDocumentorTask::setTaskName()

### Parameters

#### $name

`string`

### Returns

`string`A string representing the name of this task for log

## Sets the type of the task.

    setTaskType(string $name)

Inherited

Usually this is the name of the XML tag

inherited_from | \Task::setTaskType()
inherited_from | \PhpDocumentorTask::setTaskType()

### Parameters

#### $name

`string`

The type of this task (XML Tag)

## Set base location of all templates for this parse.

    setTemplateBase(\PhingFile $oTemplateBase)

Inherited

inherited_from | \PhpDocumentorTask::setTemplateBase()

### Parameters

#### $oTemplateBase

## Set the title for the generated documentation

    setTitle($title)

Inherited

inherited_from | \PhpDocumentorTask::setTitle()

### Parameters

#### $title

## Control whether or not warnings will be shown for undocumented elements.

    setUndocumentedelements(boolean $b)

Inherited

Useful for identifying classes and methods that haven't yet been documented.

inherited_from | \PhpDocumentorTask::setUndocumentedelements()

### Parameters

#### $b

`boolean`

## Constructs an argument string for phpDocumentor

    constructArguments() : array

### Returns

`array`

## Searches include_path for PhpDocumentor install and adjusts include_path appropriately.

    findPhpDocumentorInstall()

Inherited

inherited_from | \PhpDocumentorTask::findPhpDocumentorInstall()

### Exceptions

`\BuildException` | - if unable to find PhpDocumentor on include_path

## Returns a name

    getRegisterSlot(string $slotName)

Inherited

inherited_from | \Task::getRegisterSlot()
inherited_from | \PhpDocumentorTask::getRegisterSlot()

### Parameters

#### $slotName

`string`

## Sets the options on the passed-in phpdoc setup object.

    setPhpDocumentorOptions(\PhingPhpDocumentorSetup $phpdoc)

Inherited

inherited_from | \PhpDocumentorTask::setPhpDocumentorOptions()

### Parameters

#### $phpdoc

`\PhingPhpDocumentorSetup`

## Validates that necessary minimum options have been set.

    validate()

Based on PhpDocumentorTask::validate().

### Exceptions

`\BuildException` | if validation doesn't pass

### Properties

## Directory in which to look for configuration files.

    $configDir : \PhingFile

Inherited

inherited_from | \PhpDocumentorTask::$$configDir

## custom tags, will be recognized and put in tags[] instead of unknowntags[].

    $customtags : string

Inherited

inherited_from | \PhpDocumentorTask::$$customtags

## Default category name.

    $defaultCategoryName : string

Inherited

inherited_from | \PhpDocumentorTask::$$defaultCategoryName

## Default package name.

    $defaultPackageName : string

Inherited

inherited_from | \PhpDocumentorTask::$$defaultPackageName

##

    $description : string

Inherited

inherited_from | \Task::$$description
inherited_from | \PhpDocumentorTask::$$description

## The target directory for output files.

    $destdir : \PhingFile

Inherited

inherited_from | \PhpDocumentorTask::$$destdir

## Directory in which to look for examples.

    $examplesDir : \PhingFile

Inherited

inherited_from | \PhpDocumentorTask::$$examplesDir

## FileSet[] Filesets for files to parse.

    $filesets : array

Inherited

inherited_from | \PhpDocumentorTask::$$filesets

## files to ignore

    $ignore : string

Inherited

inherited_from | \PhpDocumentorTask::$$ignore

## Comma-separated list of tags to ignore.

    $ignoreTags : string

Inherited

inherited_from | \PhpDocumentorTask::$$ignoreTags

## ignore symlinks to other files or directories

    $ignoresymlinks : bool

## Whether to use javadoc descriptions (more primitive).

    $javadocDesc : boolean

Inherited

inherited_from | \PhpDocumentorTask::$$javadocDesc

## Whether to generate sourcecode for each file parsed.

    $linksource : boolean

Inherited

inherited_from | \PhpDocumentorTask::$$linksource

##

    $location : \Location

Inherited

inherited_from | \Task::$$location
inherited_from | \PhpDocumentorTask::$$location

## Package output format.

    $output : string

Inherited

inherited_from | \PhpDocumentorTask::$$output

## Comma-separated list of packages to output.

    $packages : string

Inherited

inherited_from | \PhpDocumentorTask::$$packages

## Whether to parse private members.

    $parsePrivate : boolean

Inherited

inherited_from | \PhpDocumentorTask::$$parsePrivate

## Whether to parse as a PEAR repository.

    $pear : boolean

Inherited

inherited_from | \PhpDocumentorTask::$$pear

##

    $programPath

## FileSet[] Project documentation (README/INSTALL/CHANGELOG) files.

    $projDocFilesets : array

Inherited

inherited_from | \PhpDocumentorTask::$$projDocFilesets

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project
inherited_from | \Task::$$project
inherited_from | \PhpDocumentorTask::$$project

## Wheter to suppress output.

    $quiet : boolean

Inherited

inherited_from | \PhpDocumentorTask::$$quiet

##

    $sourcepath

##

    $target : \Target

Inherited

inherited_from | \Task::$$target
inherited_from | \PhpDocumentorTask::$$target

##

    $taskName : string

Inherited

inherited_from | \Task::$$taskName
inherited_from | \PhpDocumentorTask::$$taskName

##

    $taskType : string

Inherited

inherited_from | \Task::$$taskType
inherited_from | \PhpDocumentorTask::$$taskType

## Base directory for locating template files.

    $templateBase : \PhingFile

Inherited

inherited_from | \PhpDocumentorTask::$$templateBase

## Title for browser window / package index.

    $title : string

Inherited

inherited_from | \PhpDocumentorTask::$$title

## Control whether or not warnings will be shown for undocumented elements. Useful for identifying classes and methods that haven't yet been documented.

    $undocumentedelements : boolean

Inherited

inherited_from | \PhpDocumentorTask::$$undocumentedelements

##

    $wrapper : \RuntimeConfigurable

Inherited

inherited_from | \Task::$$wrapper
inherited_from | \PhpDocumentorTask::$$wrapper